#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ThresholdLineStyle {
    #[serde(rename = "DOTTED")]
    Dotted,
    #[serde(rename = "SOLID")]
    Solid,
    #[serde(rename = "NONE")]
    None,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ThresholdLineStyle {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ThresholdLineStyle::Dotted => "DOTTED",
            ThresholdLineStyle::Solid => "SOLID",
            ThresholdLineStyle::None => "NONE",
            ThresholdLineStyle::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ThresholdLineStyle {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ThresholdLineStyle {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ThresholdLineStyle {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<ThresholdLineStyle, conjure_object::plain::ParseEnumError> {
        match v {
            "DOTTED" => Ok(ThresholdLineStyle::Dotted),
            "SOLID" => Ok(ThresholdLineStyle::Solid),
            "NONE" => Ok(ThresholdLineStyle::None),
            v => v.parse().map(|v| ThresholdLineStyle::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for ThresholdLineStyle {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<ThresholdLineStyle, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the ThresholdLineStyle enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
